unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  MBegin = function():Longint; stdcall;
  MEnd = function(id:Longint):Longint; stdcall;
  MEncryptPDF = function(id:Longint;infile:PChar;outfile:PChar;userpassword:PChar;ownerpassword:PChar;encryptlevel:Longint;printing:Longint;copying:Longint;changing:Longint):Longint; stdcall;
  MDecryptPDF = function(id:Longint;infile:PChar;outfile:PChar;userpassword:PChar;ownerpassword:PChar):Longint; stdcall;
  MInformation = function(id:Longint;title:PChar;subject:PChar;author:PChar;keywords:PChar;creator:PChar;producer:PChar):Longint; stdcall;
  MWatermark = function(id:Longint;text:PChar;fsize:Longint;fcolor:Longint;position:Longint;angle:Longint;xoff:Longint;yoff:Longint;background:Longint):Longint; stdcall;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    m_hDll:HMODULE;
		pMBegin:MBegin;
		pMEnd:MEnd;
    pMEncryptPDF:MEncryptPDF;
    pMDecryptPDF:MDecryptPDF;
    pMInformation:MInformation;
    pMWatermark:MWatermark;


    function LoadDLL():BOOL;
    function FreeDLL():BOOL;    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function TForm1.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := Pchar(ExtractFileDir(ParamStr(0))+'/pdfsecurity.dll');
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, 'MBegin');
	 if pFunc = nil then goto ERR_FLAG;
   pMBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEnd');
	 if pFunc = nil then goto ERR_FLAG;
   pMEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEncryptPDF');
	 if pFunc = nil then goto ERR_FLAG;
   pMEncryptPDF := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MDecryptPDF');
	 if pFunc = nil then goto ERR_FLAG;
   pMDecryptPDF := pFunc;
      
	 pFunc := GetProcAddress(m_hDll, 'MInformation');
	 if pFunc = nil then goto ERR_FLAG;
   pMInformation := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MWatermark');
	 if pFunc = nil then goto ERR_FLAG;
   pMWatermark := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;

function TForm1.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  infile:PAnsiChar;
  outfile:PAnsiChar;
  id:Longint;

  fsize:Longint;
  fcolor:Longint;
  position:Longint;
  angle:Longint;
  xoff:Longint;
  yoff:Longint;
  background:Longint;
begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load pdfsecurity.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/test3.pdf');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/test3Encrypt.pdf');

  id := pMBegin();
	if id > 0 then
  begin
		//Set PDF Information
		pMInformation(id,'title','subject','author','keywords','creator','producer');

		fsize:=16;
		fcolor:=255;//red
		position:=2;//Top-Center
		angle:=0;
		xoff:=0;
		yoff:=0;
		background:=0;
		//Stamping
		pMWatermark(id,'Watermark',fsize,fcolor,position,angle,xoff,yoff,background);

		pMEncryptPDF(id,infile,outfile,'user','owner',128,1,0,0);
		pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Encrypt finished!');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  infile:PAnsiChar;
  outfile:PAnsiChar;
  infile2:PAnsiChar;
  outfile2:PAnsiChar;
  id:Longint;

  fsize:Longint;
  fcolor:Longint;
  position:Longint;
  angle:Longint;
  xoff:Longint;
  yoff:Longint;
  background:Longint;
begin  
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load pdfsecurity.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/test1.pdf');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/test1Decrypt.pdf');

  infile2 := Pchar(ExtractFileDir(ParamStr(0))+'/test2.pdf');
  outfile2 := Pchar(ExtractFileDir(ParamStr(0))+'/test2Decrypt.pdf');

  id := pMBegin();
	if id > 0 then
  begin
		//Set PDF Information
		pMInformation(id,'title','subject','author','keywords','creator','producer');

		fsize:=16;
		fcolor:=255;//red
		position:=2;//Top-Center
		angle:=0;
		xoff:=0;
		yoff:=0;
		background:=0;
		//Stamping
		pMWatermark(id,'Watermark',fsize,fcolor,position,angle,xoff,yoff,background);
    //test1 Decrypt
		pMDecryptPDF(id,infile,outfile,'user','owner');
    //test2 Decrypt
		pMDecryptPDF(id,infile2,outfile2,'','');
		pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Decrypt finished!');
end;
end.
 